#include "../../IR/llvm.h"

bool is_void(Instruction * t) ;

bool is_phi(Instruction * t)  ;

bool is_store(Instruction * t) ;

bool is_alloca(Instruction * t) ;

bool is_ret(Instruction * t) ;
bool is_load(Instruction * t) ;
bool is_br(Instruction * t) ;

bool is_add(Instruction * t) ;
bool is_sub(Instruction * t) ;
bool is_mul(Instruction * t) ;
bool is_div(Instruction * t) ;
bool is_rem(Instruction * t) ;

bool is_fadd(Instruction * t) ;
bool is_fsub(Instruction * t) ;
bool is_fmul(Instruction * t) ;
bool is_fdiv(Instruction * t) ;

bool is_cmp(Instruction * t) ;
bool is_fcmp(Instruction * t) ;

bool is_call(Instruction * t) ;
bool is_gep(Instruction * t) ;
bool is_zext(Instruction * t) ;
bool is_fptosi(Instruction * t) ;
bool is_sitofp(Instruction * t) ;

bool is_int_binary(Instruction * t) ;

bool is_float_binary(Instruction * t) ;

bool is_binary(Instruction * t);

bool isTerminator(Instruction * t) ;

ConstantInt * CalcInt(Instruction::OpID op, Module* m, ConstantInt *v1, ConstantInt *v2) ;

ConstantFloat * CalcFloat(Instruction::OpID op, Module* m, ConstantFloat *v1, ConstantFloat *v2) ;

ConstantInt * CalcICMP(ICmpInst::ICmpOp op, Module* m, ConstantInt *v1, ConstantInt *v2) ;

ConstantInt * CalcFCMP(FCmpInst::FCmpOp op, Module* m, ConstantFloat *v1, ConstantFloat *v2) ;

