/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

#ifndef YY_YY_PARSER_HPP_INCLUDED
# define YY_YY_PARSER_HPP_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    INT = 258,                     /* INT  */
    FLOAT = 259,                   /* FLOAT  */
    ID = 260,                      /* ID  */
    greaterequal = 261,            /* greaterequal  */
    lessequal = 262,               /* lessequal  */
    Greater = 263,                 /* Greater  */
    Less = 264,                    /* Less  */
    equaL = 265,                   /* equaL  */
    NOTequal = 266,                /* NOTequal  */
    INTNUM = 267,                  /* INTNUM  */
    FLOATNUM = 268,                /* FLOATNUM  */
    VOIDTYPE = 269,                /* VOIDTYPE  */
    CONSTANT = 270,                /* CONSTANT  */
    RETURNstmt = 271,              /* RETURNstmt  */
    IF = 272,                      /* IF  */
    ELSE = 273,                    /* ELSE  */
    wHiLe = 274,                   /* wHiLe  */
    BreAk = 275,                   /* BreAk  */
    ConTiNue = 276,                /* ConTiNue  */
    LParenthesis = 277,            /* LParenthesis  */
    RParenthesis = 278,            /* RParenthesis  */
    LBracket = 279,                /* LBracket  */
    RBracket = 280,                /* RBracket  */
    Lcurlybrace = 281,             /* Lcurlybrace  */
    Rcurlybrace = 282,             /* Rcurlybrace  */
    coMMa = 283,                   /* coMMa  */
    semiCOLON = 284,               /* semiCOLON  */
    Not = 285,                     /* Not  */
    Assign = 286,                  /* Assign  */
    Minus = 287,                   /* Minus  */
    PLUS = 288,                    /* PLUS  */
    Mul = 289,                     /* Mul  */
    Div = 290,                     /* Div  */
    Mod = 291,                     /* Mod  */
    And = 292,                     /* And  */
    Or = 293,                      /* Or  */
    LOWER_THEN_ELSE = 294          /* LOWER_THEN_ELSE  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 29 "parser.y"

    COMPUnitAST* compUnit;
    DECLDefAST* declDef;
    DECLAST* decl;
    DefListAST* defList;
    DEFAST* def;
    ArraysAST* arrays;
    InitValListAST* initValList;
    INITValAST* initVal;
    FUNCDefAST* funcDef;
    FuncFParamListAST* FuncFParamList;
    FUNCFParamAST* funcFParam;
    BLOCKAST* block;
    BlockItemListAST* blockItemList;
    BLOCKItemAST* blockItem;
    STMTAST* stmt;
    RETURNStmtAST* returnStmt;
    SELECTStmtAST* selectStmt;
    ITERATIONStmtAST* iterationStmt;
    LValAST* lVal;
    PRIMARYExpAST* primaryExp;
    NUMBERAST* number;
    UNARYExpAST* unaryExp;
    CALLAST* call;
    FuncCParamListAST* funcCParamList;
    MULExpAST* mulExp;
    ADDExpAST* addExp;
    RELExpAST* relExp;
    EQExpAST* eqExp;
    LANDExpAST* lAndExp;
    LORExpAST* lOrExp;

    TYPE ty;
    UOP op;
	string* token;
	int int_val;
	float float_val;

#line 142 "parser.hpp"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE yylval;
extern YYLTYPE yylloc;

int yyparse (void);


#endif /* !YY_YY_PARSER_HPP_INCLUDED  */
