#include "llvm.h"




void Value::replace_all_use_with(Value *new_val) {
  for (auto use : use_list_) {
    auto val = dynamic_cast<Instruction *>(use.val_);
#ifdef DEBUG
    assert(val && "new_val is not a user");
#endif
    val->set_operand(use.arg_no_, new_val);
  }
}
bool Value::remove_used(Instruction* user,unsigned int i) {
  if (this != user->operands_[i]) {
    return false;
  }
  auto pos = user->use_pos_[i];
  use_list_.erase(pos);
  user->operands_[i] =
      nullptr; 
  return true;
}
bool Value::is_constant() { return name_[0] == 0; }